
From: Heiko Carstens <heiko.carstens@de.ibm.com>

Wait for interrupt and clear status pending after resetting the reader.

Signed-off-by: Martin Schwidefsky <schwidefsky@de.ibm.com>
Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 arch/s390/kernel/head.S   |   19 +++++++++++++++++--
 arch/s390/kernel/head64.S |   19 +++++++++++++++++--
 2 files changed, 34 insertions(+), 4 deletions(-)

diff -puN arch/s390/kernel/head64.S~s390-pending-interrupt-after-ipl-from-reader arch/s390/kernel/head64.S
--- 25/arch/s390/kernel/head64.S~s390-pending-interrupt-after-ipl-from-reader	Thu Jun  2 15:44:25 2005
+++ 25-akpm/arch/s390/kernel/head64.S	Thu Jun  2 15:44:26 2005
@@ -344,10 +344,25 @@ iplstart:
 	bno   .Lnoreset
         la    %r2,.Lreset              
         lhi   %r3,26
-        .long 0x83230008
+	diag  %r2,%r3,8
+	mvc   0x78(8),.Lrdrnewpsw	       # set up IO interrupt psw
+.Lwaitrdrirq:
+	lpsw  .Lrdrwaitpsw
+.Lrdrint:
+	c     %r1,0xb8			       # compare subchannel number
+	bne   .Lwaitrdrirq
+	la    %r5,.Lirb
+	tsch  0(%r5)
 .Lnoreset:
+	b     .Lnoload
+
+	.align 8
+.Lrdrnewpsw:
+	.long  0x00080000,0x80000000+.Lrdrint
+.Lrdrwaitpsw:
+	.long  0x020a0000,0x80000000+.Lrdrint
 #endif
-	
+
 #
 # everything loaded, go for it
 #
diff -puN arch/s390/kernel/head.S~s390-pending-interrupt-after-ipl-from-reader arch/s390/kernel/head.S
--- 25/arch/s390/kernel/head.S~s390-pending-interrupt-after-ipl-from-reader	Thu Jun  2 15:44:25 2005
+++ 25-akpm/arch/s390/kernel/head.S	Thu Jun  2 15:44:26 2005
@@ -345,10 +345,25 @@ iplstart:
 	bno   .Lnoreset
         la    %r2,.Lreset              
         lhi   %r3,26
-        .long 0x83230008
+	diag  %r2,%r3,8
+	mvc   0x78(8),.Lrdrnewpsw              # set up IO interrupt psw
+.Lwaitrdrirq:
+	lpsw  .Lrdrwaitpsw
+.Lrdrint:
+	c     %r1,0xb8                         # compare subchannel number
+	bne   .Lwaitrdrirq
+	la    %r5,.Lirb
+	tsch  0(%r5)
 .Lnoreset:
+        b     .Lnoload
+
+	.align 8
+.Lrdrnewpsw:
+	.long  0x00080000,0x80000000+.Lrdrint
+.Lrdrwaitpsw:
+	.long  0x020a0000,0x80000000+.Lrdrint
 #endif
-	
+
 #
 # everything loaded, go for it
 #
_
